import telebot
import requests
from jdatetime import datetime as jdatetime
from telebot import types
import time

# کلید API هواشناسی
API_KEY = "b3df32c4360cc14b7933ed5306f4badf"

# آدرس پایه برای API هواشناسی
BASE_URL_CURRENT = "http://api.openweathermap.org/data/2.5/weather"
BASE_URL_FORECAST = "http://api.openweathermap.org/data/2.5/forecast"

# تنظیمات ربات تلگرام
TOKEN = "6828642895:AAHfx6nzc2X82H-r-A3EGeQsmXI2lylx6lU"
bot = telebot.TeleBot(TOKEN)

# زمان آخرین درخواست
last_request_time = {}

# تابع بررسی عضویت کاربر در کانال
def is_user_in_channel(user_id):
    try:
        # شناسه کانال مورد نظر
        channel_id = "@lafpersian"
        # درخواست اطلاعات کاربر از کانال
        member_status = bot.get_chat_member(channel_id, user_id)
        # اگر وضعیت عضویت Member یا Administrator باشد، کاربر عضو کانال است
        if member_status.status in ['member', 'administrator', 'creator']:
            return True
        else:
            return False
    except Exception as e:
        print(f"Error checking channel membership: {e}")
        return False

# تابع دریافت اطلاعات آب و هوا برای یک شهر
def get_weather(city):
    params = {
        "q": city,
        "appid": API_KEY,
        "units": "metric",
        "lang": "fa"  # تغییر زبان به فارسی
    }
    response = requests.get(BASE_URL_CURRENT, params=params)
    data = response.json()
    return data

# تابع دریافت پیش‌بینی هوا برای 5 روز آینده
def get_forecast(city):
    params = {
        "q": city,
        "appid": API_KEY,
        "units": "metric",
        "lang": "fa",  # تغییر زبان به فارسی
        "cnt": 40  # تعداد ماکزیمم روزهای پیش‌بینی
    }
    response = requests.get(BASE_URL_FORECAST, params=params)
    data = response.json()
    return data

# دستور /start
@bot.message_handler(commands=['start'])
def send_welcome(message):
    markup = types.ReplyKeyboardMarkup(resize_keyboard=True)
    itembtn_start = types.KeyboardButton('شروع مجدد')
    markup.add(itembtn_start)
    bot.reply_to(message, "سلام! لطفاً نام شهر خود را وارد کنید.", reply_markup=markup)

# دستور /weather
@bot.message_handler(func=lambda message: True)
def send_weather(message):
    user_id = message.from_user.id
    
    # بررسی عضویت کاربر در کانال
    if not is_user_in_channel(user_id):
        bot.reply_to(message, "شما باید در کانال عضو شوید تا بتوانید از این سرویس استفاده کنید.")
        # ایجاد دکمه شیشه‌ای برای ارسال لینک کانال
        markup = types.InlineKeyboardMarkup()
        markup.add(types.InlineKeyboardButton(text="عضویت در کانال", url="https://t.me/lafpersian"))
        bot.send_message(message.chat.id, "برای عضویت در کانال، روی دکمه زیر کلیک کنید:", reply_markup=markup)
        return

    # اگر کاربر در کانال عضو بود، ادامه اجرای درخواست
    city = message.text
    user_id = message.from_user.id
    
    # بررسی زمان آخرین درخواست
    if user_id in last_request_time:
        elapsed_time = time.time() - last_request_time[user_id]
        if elapsed_time < 20:  # 5 minutes
            bot.reply_to(message, " لطفاً چند ثانیه صبر کنید و مجدد نام شهر را وارد کنید.")
            return

    last_request_time[user_id] = time.time()

    weather_data = get_weather(city)
    if weather_data["cod"] != "404":
        location = f"لوکیشن: {weather_data['name']}, {weather_data['sys']['country']}"
        current_weather = f"وضعیت هوای فعلی: {weather_data['weather'][0]['description']}"
        temperature = f"دما (درجه سانتی‌گراد): {weather_data['main']['temp']}"
        feels_like = f"حس‌شده (درجه سانتی‌گراد): {weather_data['main']['feels_like']}"
        humidity = f"رطوبت: {weather_data['main']['humidity']}%"
        jdatetime_now = jdatetime.now().strftime('%Y/%m/%d %H:%M:%S')
        bot.reply_to(message, f"{location}\n{current_weather}\n{temperature}\n{feels_like}\n{humidity}\nتاریخ شمسی: {jdatetime_now}")
        
        # فایل لوکیشن
        bot.send_location(message.chat.id, weather_data['coord']['lat'], weather_data['coord']['lon'])

        # پیش‌بینی هوا برای روزهای آینده
        forecast_data = get_forecast(city)
        forecast_message = "پیش‌بینی هوا برای روزهای آینده:\n"
        unique_dates = set()
        for forecast in forecast_data['list']:
            jalali_date = jdatetime.fromtimestamp(forecast['dt']).strftime('%Y/%m/%d')
            if jalali_date != jdatetime.now().strftime('%Y/%m/%d'):
                if jalali_date not in unique_dates:
                    avg_temp = sum(item['main']['temp'] for item in forecast_data['list'] if jdatetime.fromtimestamp(item['dt']).strftime('%Y/%m/%d') == jalali_date) / len([item for item in forecast_data['list'] if jdatetime.fromtimestamp(item['dt']).strftime('%Y/%m/%d') == jalali_date])
                    avg_weather = set(item['weather'][0]['description'] for item in forecast_data['list'] if jdatetime.fromtimestamp(item['dt']).strftime('%Y/%m/%d') == jalali_date)
                    forecast_message += f"{jalali_date}: میانگین وضعیت هوا: {', '.join(avg_weather)}, میانگین دما: {avg_temp:.1f} درجه سانتی‌گراد\n"
                    unique_dates.add(jalali_date)
        bot.send_message(message.chat.id, forecast_message)
    else:
        bot.reply_to(message, "شهر پیدا نشد. لطفاً نام شهر را به صورت صحیح وارد کنید.")

# حلقه اجرای ربات به صورت مداوم
while True:
    try:
        bot.polling(none_stop=True)
    except Exception as e:
        print(f"An error occurred: {e}")
        time.sleep(15)  # انتظار 15 ثانیه قبل از تلاش مجدد برای اجرا
